# encoding: utf-8

module OneApm
  module Agent
    class Agent
      module Helpers

        def obfuscator
          @obfuscator ||= lambda {|sql| OneApm::Agent::Database.default_sql_obfuscator(sql) }
        end

        def set_record_sql(should_record)
          state = TransactionState.tl_get
          prev = state.record_sql
          state.record_sql = should_record
          prev.nil? || prev
        end

        def set_record_tt(should_record)
          state = TransactionState.tl_get
          prev = state.record_tt
          state.record_tt = should_record
          prev.nil? || prev
        end

        def push_trace_execution_flag(should_trace=false)
          TransactionState.tl_get.push_traced(should_trace)
        end

        def pop_trace_execution_flag
          TransactionState.tl_get.pop_traced
        end
      end
    end
  end
end
