# encoding: utf-8

module OneApm
  module Collector
    class UtilizationData

      OA_REMOTE_DATA_VALID_CHARS = /^[0-9a-zA-Z_ .\/-]$/.freeze

      def harvest!
        [hostname, container_id, cpu_count, instance_type]
      end

      def merge!(*_); end
      def reset!(*_); end

      def hostname
        OneApm::Agent::Hostname.get
      end

      def container_id
        ::OneApm::Support::SystemInfo.docker_container_id
      end

      def cpu_count
        ::OneApm::Support::SystemInfo.clear_processor_info
        ::OneApm::Support::SystemInfo.num_logical_processors
      end

      def instance_type
        nil
      end

    end
  end
end
