# encoding: utf-8

require 'one_apm/collector/sampler'

module OneApm
  module Collector
    module Samplers
      class ObjectSampler < OneApm::Collector::Sampler
        named :object

        def self.supported_on_this_platform?
          OneApm::LanguageSupport.object_space_usable? && ObjectSpace.respond_to?(:live_objects)
        end

        def poll
          live_objects = ObjectSpace.live_objects
          OneApm::Manager.record_metric("GC/objects", live_objects)
        end
      end
    end
  end
end
