# encoding: utf-8

require 'one_apm/frameworks/rails'

module OneApm
  class Probe
    module Frameworks
      class Rails3 < OneApm::Probe::Frameworks::Rails

        def env
          @env ||= ::Rails.env.to_s
        end

        def rails_root
          ::Rails.root.to_s
        end

        def vendor_root
          @vendor_root ||= File.join(root,'vendor','rails')
        end

        def version
          @rails_version ||= OneApm::VersionNumber.new(::Rails::VERSION::STRING)
        end

        protected

        def install_shim
          super
          ActiveSupport.on_load(:action_controller) do
            include OneApm::Agent::Instrumentation::TransactionBase::Shim
          end
        end

      end
    end
  end
end
