# encoding: utf-8

LibraryDetection.defer do
  @name = :passenger

  depends_on do
    defined?(::PhusionPassenger)
  end

  executes do
    OneApm::Manager.logger.debug "Installing Passenger event hooks."

    ::PhusionPassenger.on_event(:stopping_worker_process) do
      OneApm::Manager.logger.debug "Passenger stopping this process, shutdown the agent."
      OneApm::Manager.agent.shutdown
    end

    ::PhusionPassenger.on_event(:starting_worker_process) do |forked|
      # We want to reset the stats from the stats engine in case any carried
      # over into the spawned process.  Don't clear them in case any were
      # cached.  We do this even in conservative spawning.
      OneApm::Manager.agent.after_fork(:force_reconnect => true)
    end
  end
end
