# encoding: utf-8

LibraryDetection.defer do
  named :puma

  def oa_puma_hooks
    Puma.cli_config.options[:worker_boot] || Puma.cli_config.options[:before_worker_boot]
  end

  depends_on do
    defined?(::Puma) &&
      defined?(::Puma::Const::VERSION) &&
      ::Puma.respond_to?(:cli_config) && 
      !oa_puma_hooks.nil?
  end

  executes do
    OneApm::Manager.logger.info 'Installing Puma support'
  end

  executes do
    oa_puma_hooks << Proc.new do
      OneApm::Manager.agent.after_fork(:force_reconnect => true)
    end
  end
end
