# encoding: utf-8

require 'one_apm/inst/rails4/active_record_subscriber'

LibraryDetection.defer do
  named :active_record_4

  depends_on do
    defined?(::ActiveRecord) &&
    defined?(::ActiveRecord::Base) &&
    defined?(::ActiveRecord::VERSION) &&
    ::ActiveRecord::VERSION::MAJOR.to_i >= 4
  end

  depends_on do
    !OneApm::Manager.config[:disable_activerecord] &&
    !OneApm::Agent::Instrumentation::ActiveRecordSubscriber.subscribed?
  end

  executes do
    OneApm::Manager.logger.info "Installing ActiveRecord #{::ActiveRecord::VERSION::MAJOR} instrumentation"
  end

  executes do
    subscriber = OneApm::Agent::Instrumentation::ActiveRecordSubscriber.new
    ActiveSupport::Notifications.subscribe('sql.active_record', subscriber)
  end
end
