# encoding: utf-8

LibraryDetection.defer do
  named :rubyprof

  depends_on do
    defined?(::RubyProf) && defined?(::OneApm::Rack::DeveloperMode) && ::OneApm::Manager.config[:developer_mode]
  end

  executes do
    ::OneApm::Manager.agent.events.subscribe(:start_transaction) do
      if ::OneApm::Rack::DeveloperMode.profiled?
        begin
          ::RubyProf.start
        rescue  => e
          OneApm::Manager.logger.debug e.message
        end
      end
    end

    ::OneApm::Manager.agent.events.subscribe(:transaction_finished) do
      if ::OneApm::Rack::DeveloperMode.profiled?
        begin
          trace = OneApm::TransactionState.tl_get.current_transaction.transaction_trace
          trace.profile = ::RubyProf.stop
        rescue  => e
          OneApm::Manager.logger.debug e.message
        end
      end
    end
  end
end
