# encoding: utf-8

require 'one_apm/rack/middleware_tracing'
require 'one_apm/rack/middleware_helper'

module OneApm
  module Rack
    class MiddlewareBase
      include MiddlewareTracing
      include OneApm::Rack::MiddlewareHelper

      attr_reader :transaction_options, :category, :target

      def initialize(app, options={})
        @app = app
        @category = :middleware
        @target   = self
        @transaction_options = {
          :transaction_name => build_transaction_name
        }
      end

      def build_transaction_name
        prefix = OneApm::TransactionNamer.prefix_for_category(nil, @category)
        "#{prefix}#{self.class.name}/call"
      end

      def middleware_ignore?
        OneApm::Manager.config[:disable_rails_middleware]
      end

    end
  end
end
