# encoding: utf-8


require 'one_apm/support/rename_rules_engine/match_expression/split_object'
require 'one_apm/support/rename_rules_engine/match_expression/url'
require 'one_apm/support/rename_rules_engine/match_expression/method'
require 'one_apm/support/dotted_hash'

module OneApm
  module Support
    class RenameRulesEngine
      module MatchExpression
        module Engine

          extend self

          def create_match_expression(expression)
            expression = DottedHash.new(expression)
            case expression[:name].downcase
              when 'splitobject'
                SplitObject.new(expression)
              when 'method'
                Method.new(expression)
              when 'url'
                Url.new(expression)
              else
                Base.new(expression)
            end
          end
        end
        
      end
    end
  end
end