# encoding: utf-8


require 'one_apm/support/rename_rules_engine/rename/base'
require 'one_apm/support/rename_rules_engine/rename/header'
require 'one_apm/support/rename_rules_engine/rename/parameter'
require 'one_apm/support/rename_rules_engine/rename/segment'
require 'one_apm/support/dotted_hash'

module OneApm
  module Support
    class RenameRulesEngine
      module Rename
        module Engine

          extend self

          def create_rename_rules(rename_hash)
            rename_hash = DottedHash.new(rename_hash)
            case rename_hash[:type].downcase
              when 'segments'
                Segment.new(rename_hash)
              when 'parameter'
                Parameter.new(rename_hash)
              when 'header'
                Header.new(rename_hash)
              else
                Base.new(rename_hash)
            end
          end
        end

      end
    end
  end
end