# encoding: utf-8

require 'one_apm/support/language_support'
require 'one_apm/support/vm/mri_vm'
require 'one_apm/support/vm/jruby_vm'
require 'one_apm/support/vm/rubinius_vm'

module OneApm
  module Support
    module VM
      def self.snapshot
        vm.snapshot
      end

      def self.vm
        @vm ||= create_vm
      end

      def self.create_vm
        if OneApm::LanguageSupport.using_engine?('jruby')
          JRubyVM.new
        elsif OneApm::LanguageSupport.using_engine?('rbx')
          RubiniusVM.new
        else
          MriVM.new
        end
      end
    end
  end
end
