# encoding: utf-8

module OneApm
  class Transaction

    OA_SUBTRANSACTION_PREFIX        = 'Nested/'.freeze
    OA_CONTROLLER_PREFIX            = 'Controller/'.freeze
    OA_MIDDLEWARE_PREFIX            = 'Middleware/Rack/'.freeze
    OA_TASK_PREFIX                  = 'OtherTransaction/Background/'.freeze
    OA_RACK_PREFIX                  = 'WebTransaction/Rack/'.freeze
    OA_SINATRA_PREFIX               = 'WebTransaction/Sinatra/'.freeze
    OA_GRAPE_PREFIX                 = 'WebTransaction/Grape/'.freeze
    OA_OTHER_TRANSACTION_PREFIX     = 'OtherTransaction/'.freeze
    OA_WEB_TRANSACTION_PREFIX       = 'WebTransaction/'.freeze  

    OA_CONTROLLER_OA_MIDDLEWARE_PREFIX = 'Controller/Middleware/Rack'.freeze

    OA_WEB_SUMMARY_METRIC   = 'WebTransaction'.freeze
    OA_OTHER_SUMMARY_METRIC = 'OtherTransaction/all'.freeze

    OA_APDEX_S = 'S'.freeze
    OA_APDEX_T = 'T'.freeze
    OA_APDEX_F = 'F'.freeze
    OA_APDEX_METRIC = 'Apdex'.freeze

    OA_QUEUE_TIME_METRIC = 'WebFrontend/QueueTime'.freeze

    OA_NESTED_TRACE_STOP_OPTIONS    = { :metric => true }.freeze
    OA_WEB_TRANSACTION_CATEGORIES   = [:controller, :uri, :rack, :sinatra, :grape, :middleware].freeze
    OA_TRANSACTION_NAMING_SOURCES   = [:child, :api].freeze

    OA_MIDDLEWARE_SUMMARY_METRICS   = ['Middleware/all'.freeze].freeze
    OA_EMPTY_SUMMARY_METRICS        = [].freeze

    OA_TRACE_OPTIONS_SCOPED         = {:metric => true, :scoped_metric => true}.freeze
    OA_TRACE_OPTIONS_UNSCOPED       = {:metric => true, :scoped_metric => false}.freeze
    
    OA_TRACE_IGNORE_OPTIONS         = {:metric => false}.freeze
    
    OA_UNKNOWN_METRIC = '(unknown)'.freeze

    OA_FAILED_TO_STOP_MESSAGE = "Failed during Transaction.stop because there is no current transaction"

  end
end
