# encoding: utf-8

module OneApm
  class Transaction

    def summary_metrics
      if @frozen_name.start_with?(OA_WEB_TRANSACTION_PREFIX)
        [OA_WEB_SUMMARY_METRIC]
      else
        background_summary_metrics
      end
    end

    def background_summary_metrics
      segments = @frozen_name.split('/')
      if segments.size > 2
        ["OtherTransaction/#{segments[1]}/all", OA_OTHER_SUMMARY_METRIC]
      else
        []
      end
    end

    def needs_middleware_summary_metrics?(name)
      name.start_with?(OA_MIDDLEWARE_PREFIX)
    end

  end
end
